/*
 * Copyright (c) 2010, Dominic DiMarco (dominic@ReallyLongAddress.com)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * -Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * -Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 * -Neither the name of the author nor the
 * names of its contributors may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

//
//  FbGraph.m
//  oAuth2Test
//
//  Created by dominic dimarco (ddimarco@room214.com @dominicdimarco) on 5/23/10.
//  Edited by Deepak on 11/01/13

/*
 Thanks to dan@hXXXX.com & adamsXXXX@gmail.com for their feedback (incorporated below)
 */

#import "FbGraph.h"
#import "SBJSON.h"
#import "FbGraphFile.h"
#import "FacebookShare.h"

#define FBGRAPH_REDIRECT_URL @"http://www.facebook.com/connect/login_success.html"

@implementation FbGraph

@synthesize facebookClientID;
@synthesize redirectUri;
@synthesize accessToken;
@synthesize webView;

@synthesize callbackObject;
@synthesize callbackSelector;

id shareid;

- (id)initWithFbClientID:fbcid {
	if (self = [super init]) {
		self.facebookClientID = fbcid;
		self.redirectUri = FBGRAPH_REDIRECT_URL;
	}
	return self;
}
+(BOOL)StoreShareid:(id)ids
{
   // NSLog(@"StoreShareid");
	shareid=ids;
    [shareid retain];
    return YES;
}

- (void)authenticateUserWithCallbackObject:(id)anObject andSelector:(SEL)selector andExtendedPermissions:(NSString *)extended_permissions andSuperView:(UIView *)super_view 
{
	self.callbackObject = anObject;
	self.callbackSelector = selector;
    
    UIColor *facebookBlue = [UIColor colorWithRed:0.42578125 green:0.515625 blue:0.703125 alpha:1.0];

    UIImage* iconImage = [UIImage imageNamed:@"fb_icn.png"];
    NSLog(@"%@ %@ %@",facebookClientID,redirectUri,extended_permissions);
    
	NSString *url_string = [NSString stringWithFormat:@"https://graph.facebook.com/oauth/authorize?client_id=%@&redirect_uri=%@&scope=%@&type=user_agent&display=touch", facebookClientID, redirectUri, extended_permissions];

	NSURL *url = [NSURL URLWithString:url_string];
	NSURLRequest *request = [NSURLRequest requestWithURL:url];
    
    //add a view to show facebook login page
    CGRect mainFrame=[super_view frame];
    [fbookVIew setBackgroundColor:facebookBlue];
	fbookVIew = [[[UIView alloc] initWithFrame:mainFrame] autorelease];
    fbookVIew.backgroundColor=[UIColor blackColor];
    fbookVIew.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
    
    UILabel *welcomeLabel = [[[UILabel alloc] init] autorelease];
    welcomeLabel.backgroundColor = facebookBlue;
    welcomeLabel.text=@"Connect to facebook";
    welcomeLabel.textColor=[UIColor whiteColor];
    welcomeLabel.font=[UIFont boldSystemFontOfSize:18];
    welcomeLabel.textAlignment=UITextAlignmentCenter;
    welcomeLabel.autoresizingMask = UIViewAutoresizingFlexibleRightMargin
    | UIViewAutoresizingFlexibleBottomMargin;
    [fbookVIew addSubview:welcomeLabel];
    
    CGRect webFrame = fbookVIew.frame;
    webFrame.origin.y = 55 ;
    UIWebView *aWebView = [[[UIWebView alloc] initWithFrame:webFrame] autorelease];
    [aWebView setOpaque:NO];
    [aWebView setBackgroundColor:facebookBlue];
    [aWebView setDelegate:self];	
	self.webView = aWebView;
	[webView loadRequest:request];	
	[fbookVIew addSubview:webView];
    
    UIButton *cancelButton = [UIButton buttonWithType:UIButtonTypeCustom];
    UIImage *closeIcon = [UIImage imageNamed:@"close_icon"];
    [cancelButton setImage:closeIcon forState:UIControlStateNormal];
    [cancelButton setTitleColor:[UIColor whiteColor] forState:UIControlStateHighlighted];
    cancelButton.showsTouchWhenHighlighted=YES;
    
//    applicable only if application is universal
    /*
    if([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone)
        [cancelButton setFrame:CGRectMake(295,16,30,30)];
    else
        [cancelButton setFrame:CGRectMake(730,16,50,50)];
     */
    
    [cancelButton setFrame:CGRectMake(297,28,closeIcon.size.width,closeIcon.size.height)];
    [cancelButton addTarget:self action:@selector(dismissAuthenticationView:) forControlEvents:UIControlEventTouchUpInside];
    
    //set frame 
    welcomeLabel.frame=CGRectMake(0,20, fbookVIew.frame.size.width ,35);
    UIImageView *iconView = [[[UIImageView alloc] initWithImage:iconImage] autorelease];
    
    iconView.frame=CGRectMake(0,20,iconImage.size.width,iconImage.size.height-5);
    
    [fbookVIew addSubview:cancelButton];
    [fbookVIew addSubview:iconView];
    
    //add animation for subview
    [fbookVIew setFrame:CGRectMake(0, mainFrame.size.height, mainFrame.size.width, mainFrame.size.height)];
    [super_view addSubview:fbookVIew];
    [UIView beginAnimations:@"SwitchToView1" context:nil];
    [UIView setAnimationDuration:0.5];
   // super_view.frame = CGRectOffset(super_view.frame, 0, -50);
    fbookVIew.frame = CGRectOffset(fbookVIew.frame, 0,  -mainFrame.size.height);
    [UIView commitAnimations];
    

}

-(void)authenticateUserWithCallbackObject:(id)anObject andSelector:(SEL)selector andExtendedPermissions:(NSString *)extended_permissions {
	
	UIWindow* window = [UIApplication sharedApplication].keyWindow;
	if (!window) {
		window = [[UIApplication sharedApplication].windows objectAtIndex:0];
	}
	
	[self authenticateUserWithCallbackObject:anObject andSelector:selector andExtendedPermissions:extended_permissions andSuperView:window];
}

- (FbGraphResponse *)doGraphGet:(NSString *)action withGetVars:(NSDictionary *)get_vars {
	
	NSString *url_string = [NSString stringWithFormat:@"https://graph.facebook.com/%@?", action];
	
	//tack on any get vars we have...
	if ( (get_vars != nil) && ([get_vars count] > 0) ) {
		
		NSEnumerator *enumerator = [get_vars keyEnumerator];
		NSString *key;
		NSString *value;
		while ((key = (NSString *)[enumerator nextObject])) {
			
			value = (NSString *)[get_vars objectForKey:key];
			url_string = [NSString stringWithFormat:@"%@%@=%@&", url_string, key, value];
			
		}//end while	
	}//end if
	
	if (accessToken != nil) {
		//now that any variables have been appended, let's attach the access token....
		url_string = [NSString stringWithFormat:@"%@access_token=%@", url_string, self.accessToken];
	}
	
	//encode the string
	url_string = [url_string stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
	
	return [self doGraphGetWithUrlString:url_string];
}

- (FbGraphResponse *)doGraphGetWithUrlString:(NSString *)url_string {
	
	FbGraphResponse *return_value = [[[FbGraphResponse alloc] init] autorelease];
	NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:url_string]];
	
	NSError *err;
	NSURLResponse *resp;
	NSData *response = [NSURLConnection sendSynchronousRequest:request returningResponse:&resp error:&err];
	
	if (resp != nil) {
		
		/**
		 * In the case we request a picture (avatar) the Graph API will return to us the actual image
		 * bits versus a url to the image.....
		 **/
		if ([resp.MIMEType isEqualToString:@"image/jpeg"]) {
			
			UIImage *image = [UIImage imageWithData:response];
			return_value.imageResponse = image;
			
		} else {
		    
			NSString *stringResponse = [[NSString alloc] initWithData:response encoding:NSUTF8StringEncoding];
			return_value.htmlResponse = stringResponse;
			[stringResponse release];			
		}
		
	} else if (err != nil) {
		return_value.error = err;
	}
	
	return return_value;
	
}

- (FbGraphResponse *)doGraphPost:(NSString *)action withPostVars:(NSDictionary *)post_vars {
	
	FbGraphResponse *return_value = [[[FbGraphResponse alloc] init] autorelease];
	
	NSString *urlString = [NSString stringWithFormat:@"https://graph.facebook.com/%@", action];
	NSLog(@"url string %@",urlString);
	NSURL *url = [NSURL URLWithString:urlString];
	NSString *boundary = @"----1010101010";
	NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
	
	NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
	[request setHTTPMethod:@"POST"];
	[request addValue:contentType forHTTPHeaderField: @"Content-Type"];
	
	NSMutableData *body = [NSMutableData data];
	[body appendData:[[NSString stringWithFormat:@"--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	
	NSEnumerator *enumerator = [post_vars keyEnumerator];
	NSString *key;
	NSString *value;
	NSString *content_disposition;
	
	//loop through all our parameters 
	while ((key = (NSString *)[enumerator nextObject])) {
		
		//if it's a picture (file)...we have to append the binary data
		if ([key isEqualToString:@"file"]) {
			
			/*
			 * the FbGraphFile object is smart enough to append it's data to 
			 * the request automagically, regardless of the type of file being
			 * attached
			 */
			FbGraphFile *upload_file = (FbGraphFile *)[post_vars objectForKey:key];
			[upload_file appendDataToBody:body];
			
			//key/value nsstring/nsstring
		} else {
			value = (NSString *)[post_vars objectForKey:key];
			
			content_disposition = [NSString stringWithFormat:@"Content-Disposition: form-data; name=\"%@\"\r\n\r\n", key];
			[body appendData:[content_disposition dataUsingEncoding:NSUTF8StringEncoding]];
			[body appendData:[value dataUsingEncoding:NSUTF8StringEncoding]];
			
		}//end else
		
		[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
		
	}//end while
	
	//add our access token
	[body appendData:[@"Content-Disposition: form-data; name=\"access_token\"\r\n\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[accessToken dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	
	//button up the request body
	[body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	
	[request setHTTPBody:body];
	[request addValue:[NSString stringWithFormat:@"%d", body.length] forHTTPHeaderField: @"Content-Length"];
	
	//quite a few lines of code to simply do the business of the HTTP connection....
    NSURLResponse *response;
    NSData *data_reply;
	NSError *err;
	
    data_reply = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&err];
	
	NSString *stringResponse = [[NSString alloc] initWithData:data_reply encoding:NSUTF8StringEncoding];
    return_value.htmlResponse = stringResponse;
	[stringResponse release];
	
//	if (err != nil) {
//		return_value.error = err;
//	}
	
	/*
	 * return the json array.  we could parse it, but that would incur overhead 
	 * some users might not want (not to mention dependencies), besides someone 
	 * may want raw strings back, keep it simple.
	 *
	 * See:  http://code.google.com/p/json-framework for an easy json parser
	 */
	
	return return_value;
}

#pragma mark -
#pragma mark UIWebViewDelegate Function

-(void) webViewDidStartLoad:(UIWebView *)webView
{
    [NSThread detachNewThreadSelector:@selector(showActivity) toTarget:self withObject:Nil];

}
- (void)webViewDidFinishLoad:(UIWebView *)_webView {
    
    [self activityHide];
    
	/**
	 * Since there's some server side redirecting involved, this method/function will be called several times
	 * we're only interested when we see a url like:  http://www.facebook.com/connect/login_success.html#access_token=..........
	 */
	
	//get the url string
	NSString *url_string = [((_webView.request).URL) absoluteString];
	//NSLog(@"url_string : %@",url_string);
	//looking for "access_token="
	NSRange access_token_range = [url_string rangeOfString:@"access_token="];
	
	//looking for "error_reason=user_denied"
	NSRange cancel_range = [url_string rangeOfString:@"error_reason=user_denied"];
	NSRange login_range = [url_string rangeOfString:@"login.php"];
	//it exists?  coolio, we have a token, now let's parse it out....
	if (access_token_range.length > 0) {
		//cancelButton.hidden = YES;
		//we want everything after the 'access_token=' thus the position where it starts + it's length
		int from_index = access_token_range.location + access_token_range.length;
		NSString *access_token = [url_string substringFromIndex:from_index];
		
		//finally we have to url decode the access token
		access_token = [access_token stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
		//NSLog(@"access token=%@",access_token);
		//remove everything '&' (inclusive) onward...
		NSRange period_range = [access_token rangeOfString:@"&"];
		
		//move beyond the .
		access_token = [access_token substringToIndex:period_range.location];
		
		//store our request token....
		self.accessToken = access_token;
		
		//remove our window
		UIWindow* window = [UIApplication sharedApplication].keyWindow;
		if (!window) {
			window = [[UIApplication sharedApplication].windows objectAtIndex:0];
		}
		// [cancelButton removeFromSuperview];
        
	//	[self.webView removeFromSuperview];
        self.webView=nil;
        [fbookVIew removeFromSuperview];
		/*
		//tell our callback function that we're done logging in :)
        //NSLog(@"callbackObject == %@",callbackObject);
		if ( (callbackObject != nil) && (callbackSelector != nil) ) {
			[callbackObject performSelector:callbackSelector];
		}
         */
		//NSLog(@"*********LOGIN SUCCESS********");
//       [webView setBackgroundColor:[UIColor clearColo®r]];
//       [webView setOpaque:NO];
       
        [shareid shareOnFacebook];
       
        
		//the user pressed cancel
	} else if (cancel_range.length > 0 && login_range.length == 0) {
		//remove our window
		UIWindow* window = [UIApplication sharedApplication].keyWindow;
		if (!window) {
			window = [[UIApplication sharedApplication].windows objectAtIndex:0];
		}
		
		//[self.webView removeFromSuperview];
        self.webView=nil;
        [fbookVIew removeFromSuperview];
		/*
		//tell our callback function that we're done logging in :)
		if ( (callbackObject != nil) && (callbackSelector != nil) ) {
			[callbackObject performSelector:callbackSelector];
		}
		*/
	}
    if ([url_string isEqualToString:@"http://m.facebook.com/home.php?_rdr"]) {
        
        //[self.webView removeFromSuperview];
        self.webView=nil;
        [fbookVIew removeFromSuperview];
    }
   
}
+(void)signOut {
    
  //  NSLog(@"signOut");
//    NSLog(@"self.accessToken ==== %@",self.accessToken);
    NSHTTPCookieStorage *cookieStorage = [NSHTTPCookieStorage sharedHTTPCookieStorage];
    for (NSHTTPCookie *each in cookieStorage.cookies) {
        [cookieStorage deleteCookie:each];
    }
}

- (void)dismissAuthenticationView:(id)sender
{
    
    //remove subview with animation
    CGRect parentFrame = fbookVIew.frame;
    
    [UIView animateWithDuration:0.3 animations:^{
        [fbookVIew setFrame:CGRectMake(0, parentFrame.size.height, parentFrame.size.width, parentFrame.size.height)];
    } completion:^(BOOL finished) {
        webView =nil;
        [fbookVIew removeFromSuperview];
    }];
}

-(void) showActivity
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc]init];
	//NSLog(@"**** SHOW ACTIVITY upload to server*******");
	activityIndicator = [[UIActivityIndicatorView alloc]initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
//	activityIndicator.frame = CGRectMake(100,250, 25, 25);
    activityIndicator.frame=CGRectMake(fbookVIew.frame.size.width/2-18,fbookVIew.frame.size.height/2-55 , activityIndicator.frame.size.width, activityIndicator.frame.size.height);
    //activityIndicator.center = fbookVIew.center;
	[webView addSubview:activityIndicator];
	[activityIndicator startAnimating];
	[pool drain]; 
}

-(void) activityHide
{
        if([activityIndicator respondsToSelector:@selector(stopAnimating)])
        {
           // NSLog(@"**** ACTIVITY HIDE uplad to server ******");
            [activityIndicator stopAnimating];
            [activityIndicator removeFromSuperview];
            [activityIndicator release];
        }
    else
    {
       // NSLog(@"HI");
    }
}


-(void) dealloc {
	
	[facebookClientID release];
	[redirectUri release];
	[accessToken release];
	[webView release];
    [super dealloc];
}

@end